#include <math.h>
#include "blocks.h"
#include "FFTalg.h"


// length of the filter impulse response and 
// filter IR coefficients
int N=10;
float h[]={0.0040,-0.0120,-0.0411,0.1147,0.4344,0.4344,0.1147,-0.0411,-0.0120,0.0040};



/*--------------------------------------------------*/    
extern float H[];
extern float theta[];

void init( void)
{
	int i=0;
	
	for (i=0; i<N; i++)
	{
		// multiplying with -1 to compensate for the sign change
		// at the output of the DSP filter
		H[2*i]=-h[i];
		H[2*i+1]=0;
	}
	
	for (; i<BLKSZ; i++)
	{
		H[2*i]=0;
		H[2*i+1]=0;
	}

	fft(H,BLKSZ);
	

}

void processing( void * buffer, float H[], float theta[])
{
  
  float *workbuf = buffer; // only to get correct pointer type
  
	  block_cmplx_zeropad( workbuf, HOPSZ, BLKSZ);
	  fft(workbuf,BLKSZ);
	  block_float_cmplx_multiply( workbuf, H, BLKSZ);
	  ifft(workbuf,BLKSZ);

}
